#include<stdio.h>
#include<stdlib.h>
#include<string.h>

int getNextLine(char filename[], char line[], int maxlinesize) {
	static int firstrun = 1;
	static FILE *fp;
	memset(line, 0, maxlinesize);
	if (firstrun) {
		fp = fopen(filename, "r");
		if (fp == NULL) {
			fprintf(stderr, "Error opening file \"%s\" for reading.\n", filename);
			exit(1);
		}
		firstrun = 0;
	}
	char *lineptr = NULL;
	size_t linecap = 0;
	ssize_t linelen;
	linelen = getline(&lineptr, &linecap, fp);	
	if (linelen == -1) {
		fclose(fp);
		firstrun = 1;
		return 0;
	}
	char *newline = strchr(lineptr, '\n');
	if (newline) {
		*newline='\0';
		linecap--;
	}

	if (linecap > maxlinesize) {
		fprintf(stderr, "Warning: Missing/Incomplete words due to insufficient space.\n");
		strncpy(line, lineptr, maxlinesize-1);
	}
	else {
		strcpy(line, lineptr);
	}
	return 1;
}
	 
		
